# AmoebaPiTorsionForce Class Reference

This class implements the Amoeba pi-torsion interaction. More...

`#include <AmoebaPiTorsionForce.h>`

Inheritance diagram for AmoebaPiTorsionForce:

List of all members.

## Classes
class | PiTorsionInfo
| This is an internal class used to record information about a torsion.
## Public Member Functions
| AmoebaPiTorsionForce ()
| Create an AmoebaPiTorsionForce.
int | getNumPiTorsions () const
| Get the number of pi torsion terms in the potential function.
int | addPiTorsion (int particle1, int particle2, int particle3, int particle4, int particle5, int particle6, double k)
| Add a torsion term to the force field.
void | getPiTorsionParameters (int index, int &particle1, int &particle2, int &particle3, int &particle4, int &particle5, int &particle6, double &k) const
| Get the force field parameters for a torsion term.
void | setPiTorsionParameters (int index, int particle1, int particle2, int particle3, int particle4, int particle5, int particle6, double k)
| Set the force field parameters for a pi torsion term.
void | updateParametersInContext (Context &context)
| Update the per-torsion parameters in a Context to match those stored in this Force object.
## Protected Member Functions
ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements the Amoeba pi-torsion interaction.

To use it, create an AmoebaPiTorsionForce object then call addPiTorsion() once for each torsion. After a torsion has been added, you can modify its force field parameters by calling setPiTorsionParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

AmoebaPiTorsionForce | ( |  | ) |

Create an AmoebaPiTorsionForce.

## Member Function Documentation

int addPiTorsion | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | int | particle5,
|  | int | particle6,
|  | double | k |
| ) |  |  |

Add a torsion term to the force field.

Parameters:

  | particle1 | the index of the first particle connected by the torsion
  | particle2 | the index of the second particle connected by the torsion
  | particle3 | the index of the third particle connected by the torsion
  | particle4 | the index of the fourth particle connected by the torsion
  | particle5 | the index of the fifth particle connected by the torsion
  | particle6 | the index of the sixth particle connected by the torsion
  | k | the force constant for the torsion

Returns:
  the index of the torsion that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

int getNumPiTorsions | ( |  | ) | const`[inline]`

Get the number of pi torsion terms in the potential function.

void getPiTorsionParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | int & | particle4,
|  | int & | particle5,
|  | int & | particle6,
|  | double & | k |
| ) |  |  | const

Get the force field parameters for a torsion term.

Parameters:

  | index | the index of the torsion for which to get parameters
  | particle1 | the index of the first particle connected by the torsion
  | particle2 | the index of the second particle connected by the torsion
  | particle3 | the index of the third particle connected by the torsion
  | particle4 | the index of the fourth particle connected by the torsion
  | particle5 | the index of the fifth particle connected by the torsion
  | particle6 | the index of the sixth particle connected by the torsion
  | k | the force constant for the torsion

void setPiTorsionParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | int | particle5,
|  | int | particle6,
|  | double | k |
| ) |  |  |

Set the force field parameters for a pi torsion term.

Parameters:

  | index | the index of the torsion for which to set parameters
  | particle1 | the index of the first particle connected by the torsion
  | particle2 | the index of the second particle connected by the torsion
  | particle3 | the index of the third particle connected by the torsion
  | particle4 | the index of the fourth particle connected by the torsion
  | particle5 | the index of the fifth particle connected by the torsion
  | particle6 | the index of the sixth particle connected by the torsion
  | k | the force constant for the torsion

void updateParametersInContext | ( | Context & | context | ) |

Update the per-torsion parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setPiTorsionParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

The only information this method updates is the values of per-torsion parameters. The set of particles involved in a torsion cannot be changed, nor can new torsions be added.

The documentation for this class was generated from the following file:

- AmoebaPiTorsionForce.h